﻿namespace CachedRepository
{
    using System;
    using CachedRepository.BussinesLogic;
    using CachedRepository.DataAccess;
    using CachedRepository.DataAccess.UserProfiles;
    using CachedRepository.UnityExtensions;
    using Microsoft.Practices.Unity;

    class Program
    {
        static void Main(string[] args)
        {
            IUnityContainer container = BuildContainer();

            var profileProcessor = container.Resolve<SomeUserProfileProcessing>();

            Console.WriteLine("=========== First call");
            profileProcessor.ProcessProfile();

            Console.WriteLine("=========== Second call");
            profileProcessor.ProcessProfile();

            Console.WriteLine("Press any key ...");
            Console.ReadKey(intercept: true);
        }

        private static IUnityContainer BuildContainer()
        {
            IUnityContainer container = new UnityContainer();

            // Регистрируем классы слоя доступа к данным

            // Комментируя следующую строку можно управлять кэшированием
            container.RegisterType<IUserProfileRepository, CachedUserProfileRepository>();
            container.RegisterWithOptionalName<IUserProfileRepository, EFUserProfileRepository>("DirectDataAccess");

            // Регистрируем классы бизнес-логики
            container.RegisterType<SomeUserProfileProcessing>();

            return container;
        }
    }
}