﻿namespace CachedRepository.UnityExtensions
{
	using Microsoft.Practices.Unity;

	public static class UnityExtensions
	{
		public static void RegisterWithOptionalName<TInterface, TImpl>(this IUnityContainer container, string name)
			where TImpl : TInterface
		{
			if (container.IsRegistered<TInterface>())
				container.RegisterType<TInterface, TImpl>(name);
			else
				container.RegisterType<TInterface, TImpl>();
		}
	}
}
